import { XYPosition, Dimensions, ElementData } from './flow'
import { NodeHandleBounds, Node } from './node'
import { Edge } from './edge'
export declare type NodeDimensionChange = {
  id: string
  type: 'dimensions'
  dimensions: Dimensions
  handleBounds?: NodeHandleBounds
}
export declare type NodePositionChange = {
  id: string
  type: 'position'
  position?: XYPosition
  dragging?: boolean
}
export declare type NodeSelectionChange = {
  id: string
  type: 'select'
  selected: boolean
}
export declare type NodeRemoveChange = {
  id: string
  type: 'remove'
}
export declare type NodeAddChange<Data = ElementData> = {
  item: Node<Data>
  type: 'add'
}
export declare type NodeResetChange<Data = ElementData> = {
  item: Node<Data>
  type: 'reset'
}
export declare type NodeChange =
  | NodeDimensionChange
  | NodePositionChange
  | NodeSelectionChange
  | NodeRemoveChange
  | NodeAddChange
  | NodeResetChange
export declare type EdgeSelectionChange = NodeSelectionChange
export declare type EdgeRemoveChange = NodeRemoveChange
export declare type EdgeAddChange<Data = ElementData> = {
  item: Edge<Data>
  type: 'add'
}
export declare type EdgeResetChange<Data = ElementData> = {
  item: Edge<Data>
  type: 'reset'
}
export declare type EdgeChange = EdgeSelectionChange | EdgeRemoveChange | EdgeAddChange | EdgeResetChange
export declare type ElementChange = NodeChange | EdgeChange
